package api

import (
	"zjmud.xyz/phyer/rbcp/controllers"
	"zjmud.xyz/phyer/rbcp/middleware"

	"github.com/gin-gonic/gin"
)

func SetupRoutes(r *gin.Engine) {
	auth := r.Group("/auth")
	{
		auth.POST("/login", controllers.Login)
		auth.POST("/register", controllers.Register)
	}

	admin := r.Group("/admin")
	admin.Use(middleware.RBACMiddleware("admin", "full-access"))
	{
		admin.POST("/roles", controllers.CreateRole)
		admin.POST("/users", controllers.CreateUser)
		admin.POST("/permissions", controllers.CreatePermission)
		admin.POST("/user-groups", controllers.CreateUserGroup)
		admin.POST("/assign-role", controllers.AssignRoleToUser)
		admin.POST("/assign-permission", controllers.AssignPermissionToRole)
	}
}
